#include <sys/stat.h>

#define DREADY 1
#define TREADY 4

extern volatile int *console;

int
write (fd, buf, nbyte)
     int fd;
     const void *buf;
     size_t nbyte;
{

    int nlfilt = 1;
    int data, stat;
    int nsave;
    int rxadata;
    int rxmask;

    nsave = nbyte;
    while (nbyte > 0)
      {
	  while ((console[1] & TREADY) == 0);
	  console[0] = (0x0ff & *(char *) buf);
	  if (nlfilt && (*(char *)buf == '\n'))
	    {
		while ((console[1] & TREADY) == 0);
		console[0] = (int) '\r';
	    }
	  buf++;
	  nbyte--;
      }
    return (nsave);
}

