/*

    LEON2/3 LIBIO low-level routines 
    Written by Jiri Gaisler.
    Copyright (C) 2004  Gaisler Research AB

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

	.text
	.global __longjmp
__longjmp: ta 3			!ST_FLUSH_WINDOWS
	ld [%o0], %o7		/* Return PC.  */
	ld [%o0 + 4], %fp	/* Saved SP.  */
	sub %fp, 64, %sp	/* Allocate a register save area.  */

	/* if (%o1 == 0) %o1 = 1; */
	tst %o1
	be,a Ldone
	mov 1, %o1

Ldone:	retl
	/* On the way out, put the return value in %o0.  */
	restore %o1, 0, %o0

	.global __setjmp
__setjmp:
	/* Save our return PC and SP.  */
	st %o7, [%o0]
	st %sp, [%o0 + 4]
	retl
	clr %o0

